.if n .ds Q \&"
.if t .ds Q ``
.if n .ds U \&"
.if t .ds U ''
.TH "Mutt" 1 
.tr \&
.nr bi 0
.nr ll 0
.nr el 0
.de DS
..
.de DE
..
.de Pp
.ie \\n(ll>0 \{\
.ie \\n(bi=1 \{\
.nr bi 0
.if \\n(t\\n(ll=0 \{.IP \\(bu\}
.if \\n(t\\n(ll=1 \{.IP \\n+(e\\n(el.\}
.\}
.el .sp 
.\}
.el \{\
.ie \\nh=1 \{\
.LP
.nr h 0
.\}
.el .PP 
.\}
..
.SH NAME

.Pp
mutt - The Mutt Mail User Agent
.Pp
.SH SYNOPSIS

.Pp
mutt [ -hnpRvxyzZ ]
[ -a \fIfile\fP ]
[ -b \fIaddress\fP ]
[ -c \fIaddress\fP ]
[ -f \fImailbox\fP ]
[ -F \fImuttrc\fP ]
[ -H \fIdraftfile\fP ]
[ -i \fIinclude\fP ]
[ -m \fItype\fP ]
[ -s \fIsubject\fP ]
[ \fIaddress\fP ... ]
.Pp
.SH DESCRIPTION

.Pp
Mutt is a small but very powerful text based program for reading electronic
mail under unix operating systems, including support color terminals, MIME,
and a threaded sorting mode.
.Pp
.SH OPTIONS

.Pp
.nr ll +1
.nr t\n(ll 2
.if \n(ll>1 .RS
.IP "-a \fIfile\fP"
.nr bi 1
.Pp
Attach a file to your message using MIME.
.IP "-b \fIaddress\fP"
.nr bi 1
.Pp
Specify a blind-carbon-copy (BCC) recipient
.IP "-c \fIaddress\fP"
.nr bi 1
.Pp
Specify a carbon-copy (CC) recipient
.IP "-f \fImailbox\fP"
.nr bi 1
.Pp
Specify which mailbox to load.
.IP "-F \fImuttrc\fP"
.nr bi 1
.Pp
Specify an initialization file to read instead of ~/.muttrc
.IP "-h"
.nr bi 1
.Pp
Display help.
.IP "-H \fIdraft\fP"
.nr bi 1
.Pp
Specify a draft file which contains header and body to use to send a
message.
.IP "-i \fIinclude\fP"
.nr bi 1
.Pp
Specify a file to include into the body of a message.
.IP "-m \fItype\fP "
.nr bi 1
.Pp
specify a default mailbox type
.IP "-n"
.nr bi 1
.Pp
Causes Mutt to bypass the system configuration file.
.IP "-p"
.nr bi 1
.Pp
Resume a postponed message.
.IP "-R"
.nr bi 1
.Pp
Open a mailbox in \fIread-only\fP mode.
.IP "-s \fIsubject\fP"
.nr bi 1
.Pp
Specify the subject of the message.
.IP "-v"
.nr bi 1
.Pp
Display the Mutt version number and compile-time definitions.
.IP "-x"
.nr bi 1
.Pp
Emulate the mailx compose mode.
.IP "-y"
.nr bi 1
.Pp
Start Mutt with a listing of all mailboxes specified by the \fImailboxes\fP
command.
.IP "-z"
.nr bi 1
.Pp
When used with -f, causes Mutt not to start if there are no messages in the
mailbox.
.IP "-Z"
.nr bi 1
.Pp
Causes Mutt to open the first mailbox specified by the \fImailboxes\fP
command which contains new mail.
.if \n(ll>1 .RE
.nr ll -1
.Pp
.SH ENVIRONMENT

.Pp
.nr ll +1
.nr t\n(ll 2
.if \n(ll>1 .RS
.IP "EDITOR"
.nr bi 1
.Pp
Editor to invoke when composing a message.
.IP "HOME"
.nr bi 1
.Pp
Full path of the user's home directory.
.IP "MAIL"
.nr bi 1
.Pp
Full path of the user's spool mailbox.
.IP "PGPPATH"
.nr bi 1
.Pp
Directory in which the user's PGP public keyring can be found.
.IP "REPLYTO"
.nr bi 1
.Pp
Default Reply-To address.
.IP "VISUAL"
.nr bi 1
.Pp
Editor to invoke when the ~v command is given in the builtin editor.
.if \n(ll>1 .RE
.nr ll -1
.Pp
.SH FILES

.Pp
.nr ll +1
.nr t\n(ll 2
.if \n(ll>1 .RS
.IP "~/.muttrc"
.nr bi 1
.Pp
User configuration file.
.IP "/usr/local/share/Muttrc"
.nr bi 1
.Pp
System-wide configuration file.
.IP "/tmp/muttXXXXXX"
.nr bi 1
.Pp
Temporary files created by Mutt.
.IP "~/.mailcap"
.nr bi 1
.Pp
User definition for handling non-text MIME types.
.IP "/usr/local/share/mailcap"
.nr bi 1
.Pp
System definition for handing non-text MIME types.
.IP "~/.mime.types"
.nr bi 1
.Pp
User's personal mapping between MIME types and file extensions.
.IP "/usr/local/share/mime.types"
.nr bi 1
.Pp
System mapping between MIME types and file extensions.
.Pp
.if \n(ll>1 .RE
.nr ll -1
.Pp
.SH BUGS

.Pp
suspend/resume while editing a file with an external editor does not work
under SunOS 4.x if you use the curses lib in /usr/5lib.  It \fIdoes\fP work
with the S-Lang library, however.
.Pp
Resizing the screen while using an external pager causes Mutt to go haywire
on some systems.
.Pp
suspend/resume does not work under Ultrix.
.Pp
.SH SEE ALSO

.Pp
curses(3), ncurses(3), sendmail(1), smail(1), mailcap(5)
.Pp
Mutt Home Page: http://www.cs.hmc.edu/~me/mutt/
.Pp
.SH AUTHOR

.Pp
Michael Elkins <me@cs.hmc.edu>
.Pp
http://www.cs.hmc.edu/~me